<template>
  <div class="page-box" style="position: relative;">
    <el-form
      ref="formRestaurantFoodTypeInfo"
      :model="formData"
      :size="layoutStore.defaultFormItemSize"
      label-width="120px"
      label-position="right"
      @submit.prevent
    >
      <filter-box :item-width="350" @search="refreshFormRestaurantFoodTypeInfo()" @reset="resetFormRestaurantFoodTypeInfo">
        <el-form-item label="种类名称">
          <el-input
            class="filter-item"
            v-model="formFilter.nameFilter"
            type="text"
            placeholder=""
            :clearable="true"
            :show-word-limit="false"
            maxlength=""
          />
        </el-form-item>
        <el-form-item label="是否启用">
          <el-select
            class="filter-item"
            v-model="formFilter.enableFilter"
            placeholder=""
            :clearable="true"
            :filterable="true"
            @visible-change="enableFilterWidget.onVisibleChange"
          >
            <el-option
              v-for="item in enableFilterWidgetDropdownList"
              :key="item.id"
              :label="item.name"
              :value="item.id"
            />
          </el-select>
        </el-form-item>
      </filter-box>
    </el-form>
    <table-box
      ref="restaurantFoodType"
      class="page-table"
      :data="restaurantFoodTypeWidgetDataList"
      :size="layoutStore.defaultFormItemSize"
      :row-config="{isCurrent: false, isHover: true}"
      :seq-config="{startIndex: ((restaurantFoodTypeWidgetCurrentPage - 1) * restaurantFoodTypeWidgetPageSize)}"
      :sort-config="{remote: true}"
      :hasExtend="true"
      @sort-change="restaurantFoodTypeWidget.onSortChange"
      @refresh="restaurantFoodTypeWidget.refreshTable()"
    >
      <template #operator>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          :disabled="!checkPermCodeExist('formRestaurantFoodTypeInfo:formRestaurantFoodTypeInfo:add')"
          @click="onAddClick()"
          >
          新建
        </el-button>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          :disabled="!checkPermCodeExist('formRestaurantFoodTypeInfo:formRestaurantFoodTypeInfo:export')"
          @click="onExportClick()"
          >
          导出
        </el-button>
        <el-upload
          class="btn-import"
          :auto-upload="false"
          action=""
          :show-file-list="false"
          accept=".xls,.xlsx"
          style="display: inline-block;"
          :disabled="!checkPermCodeExist('formRestaurantFoodTypeInfo:formRestaurantFoodTypeInfo:import')"
          :on-change="onImportClick"
        >
          <template #trigger>
            <el-button
              type="primary"
              :size="layoutStore.defaultFormItemSize"
              :disabled="!checkPermCodeExist('formRestaurantFoodTypeInfo:formRestaurantFoodTypeInfo:import')"
            >
              导入
            </el-button>
          </template>
        </el-upload>
      </template>
      <vxe-column title="序号" type="seq" :index="restaurantFoodTypeWidget.getTableIndex" :width="80" />
      <vxe-column title="种类名称" field="name" />
      <vxe-column title="是否启用" field="enableDictMap.name" />
      <vxe-column title="显示顺序" field="showOrder" />
      <vxe-column title="描述" field="description" />
      <vxe-column title="操作" fixed="right">
        <template v-slot="scope">
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onEditClick(scope.row)"
            :disabled="!checkPermCodeExist('formRestaurantFoodTypeInfo:formRestaurantFoodTypeInfo:edit')"
          >
            编辑
          </el-button>
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onDeleteClick(scope.row)"
            :disabled="!checkPermCodeExist('formRestaurantFoodTypeInfo:formRestaurantFoodTypeInfo:delete')"
          >
            删除
          </el-button>
        </template>
      </vxe-column>
      <template slot="empty">
        <div class="table-empty unified-font">
          <img src="@/assets/img/empty.png">
          <span>暂无数据</span>
        </div>
      </template>
      <!-- 分页 -->
      <template #pagination>
        <el-row type="flex" justify="end" style="margin-top: 10px;">
          <el-pagination
            :total="restaurantFoodTypeWidgetTotalCount"
            :current-page="restaurantFoodTypeWidgetCurrentPage"
            :page-size="restaurantFoodTypeWidgetPageSize"
            :page-sizes="[10, 20, 50, 100]"
            layout="total, prev, pager, next, sizes"
            @current-change="restaurantFoodTypeWidget.onCurrentPageChange"
            @size-change="restaurantFoodTypeWidget.onPageSizeChange">
          </el-pagination>
        </el-row>
      </template>
    </table-box>
    <label v-if="subPage" class="page-close-box" @click="onCancel()">
      <img src="@/assets/img/back2.png" alt="">
    </label>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formRestaurantFoodTypeInfo',
};
</script>

<script setup lang="ts">
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode } from '@/common/utils';
import { RestaurantFoodTypeData } from '@/api/generated/restaurantFoodTypeController';
import { RestaurantFoodTypeController } from '@/api/generated';
import FormEditRestaurantFoodType from '@/pages/generated/formEditRestaurantFoodType.vue';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
  }>(),
  {
    subPage: 0,
  },
);

const formFilter = reactive({
  // 种类名称
  nameFilter: undefined,
  // 是否启用
  enableFilter: undefined,
});
const formFilterCopy = reactive({
  // 种类名称
  nameFilter: undefined,
  // 是否启用
  enableFilter: undefined,
});

const onCancel = () => {
  layoutStore.removeCachePage(route.name as string);
  route.meta.refreshParentCachedPage = true;
  router.go(-1);
};

const onResume = () => {
  refreshFormRestaurantFoodTypeInfo();
};

/**
 * 表格组件数据获取函数，返回Promise
 */
const loadRestaurantFoodTypeWidgetData = (params: ANY_OBJECT) => {
  if (params == null) params = {};
  params = {
    ...params,
    restaurantFoodTypeDtoFilter:{
    name : formFilter.nameFilter,
    enable : formFilter.enableFilter
    }
  };
  return new Promise((resolve, reject) => {
    RestaurantFoodTypeController.list(params).then(res => {
      resolve({
        dataList: res.data.dataList,
        totalCount: res.data.totalCount
      });
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 表格组件数据获取检测函数，返回true正常获取数据，返回false停止获取数据
 */
const loadRestaurantFoodTypeVerify = () => {
  formFilterCopy.nameFilter = formFilter.nameFilter;
  formFilterCopy.enableFilter = formFilter.enableFilter;
  return true;
};
/**
 * 新建
 */
const onAddClick = (row?: RestaurantFoodTypeData) => {
  let params: ANY_OBJECT = {
  };

  Dialog
    .show('新建', FormEditRestaurantFoodType, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      restaurantFoodTypeWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 编辑
 */
const onEditClick = (row?: RestaurantFoodTypeData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  Dialog
    .show('编辑', FormEditRestaurantFoodType, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      restaurantFoodTypeWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 导出
 */
const onExportClick = (row?: RestaurantFoodTypeData) => {
  let params: ANY_OBJECT = {
    restaurantFoodTypeDtoFilter: {
      name: formFilter.nameFilter,
      enable: formFilter.enableFilter,
    }
  };

  RestaurantFoodTypeController.export(params, '.xlsx').then(res => {
    ElMessage.success('导出成功');
  }).catch(e => {
    ElMessage.error(e.errorMessage);
  });
};
/**
 * 导入
 */
const onImportClick = (file) => {
  let params: ANY_OBJECT = {
    importFile: file.raw,
    // 是否忽略表头
    skipHeader: false
  };

  RestaurantFoodTypeController.import(params).then(res => {
    ElMessage.success('导入成功');
    restaurantFoodTypeWidget.refreshTable();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
/**
 * 删除
 */
const onDeleteClick = (row?: RestaurantFoodTypeData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  RestaurantFoodTypeController.delete(params).then(res => {
    ElMessage.success('删除成功');
    restaurantFoodTypeWidget.refreshTable(false, 1);
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
// 表格组件表格组件参数
const restaurantFoodTypeOptions: TableOptions<RestaurantFoodTypeData> = {
  loadTableData: loadRestaurantFoodTypeWidgetData,
  verifyTableParameter: loadRestaurantFoodTypeVerify,
  paged: true,
  rowSelection: false,
  orderFieldName: undefined,
  ascending: true,
};
// 表格组件表格组件
const restaurantFoodType = ref();
const restaurantFoodTypeWidget = useTable(restaurantFoodTypeOptions);
const {
  dataList: restaurantFoodTypeWidgetDataList,
  currentPage: restaurantFoodTypeWidgetCurrentPage,
  pageSize: restaurantFoodTypeWidgetPageSize,
  totalCount: restaurantFoodTypeWidgetTotalCount,
} = restaurantFoodTypeWidget;
/**
 * 是否启用下拉数据获取函数
 */
const loadEnableFilterDropdownList = (): Promise<ListData<DictData>> => {
  return Promise.resolve({
    dataList: StaticDict.Enable.getList(),
  });
};
// 是否启用配置参数
const enableFilterOptions: DropdownOptions<DictData> = {
  loadData: loadEnableFilterDropdownList,
  isTree: false,
};
// 是否启用下拉组件
const enableFilterWidget = useDropdown(enableFilterOptions);
const { dropdownList: enableFilterWidgetDropdownList } = enableFilterWidget
const refreshFormRestaurantFoodTypeInfo = () => {
  // 刷新段落
  restaurantFoodTypeWidget.refreshTable();
};
/**
 * 重置过滤值
 */
const resetFormRestaurantFoodTypeInfo = () => {
  formFilter.nameFilter = undefined;
  formFilterCopy.nameFilter = undefined;
  formFilter.enableFilter = undefined;
  formFilterCopy.enableFilter = undefined;
  refreshFormRestaurantFoodTypeInfo();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormRestaurantFoodTypeInfo();
};
const formInit = () => {
  enableFilterWidget.onVisibleChange(true).catch(e => {console.error(e)});
  refreshFormRestaurantFoodTypeInfo();
};

onMounted(() => {
  formInit();
});
</script>